Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/Crossovers/PWRCrossover.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/Crossovers/PWRCrossover.cs	(revision 6260)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/Crossovers/PWRCrossover.cs	(revision 6260)
@@ -0,0 +1,52 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.Scheduling.Interfaces;
+
+namespace HeuristicLab.Problems.Scheduling.Encodings.PermutationWithRepetition.Crossovers {
+  [Item("PWRCrossover", "An operator which crosses two JSM representations.")]
+  [StorableClass]
+  public abstract class PWRCrossover : JSSPCrossover<PWREncoding>, IPWROperator {
+
+    [StorableConstructor]
+    protected PWRCrossover(bool deserializing) : base(deserializing) { }
+    protected PWRCrossover(PWRCrossover original, Cloner cloner) : base(original, cloner) { }
+    public PWRCrossover()
+      : base() {
+    }
+
+    public abstract PWREncoding Crossover(IRandom random, PWREncoding parent1, PWREncoding parent2);
+
+    public override IOperation Apply() {
+      ItemArray<PWREncoding> parents = ParentsParameter.ActualValue;
+
+      ChildParameter.ActualValue =
+        Crossover(RandomParameter.ActualValue, parents[0] as PWREncoding, parents[1] as PWREncoding);
+
+      return base.Apply();
+    }
+  }
+}
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/Crossovers/PWRGOXCrossover.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/Crossovers/PWRGOXCrossover.cs	(revision 6260)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/Crossovers/PWRGOXCrossover.cs	(revision 6260)
@@ -0,0 +1,95 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Problems.Scheduling.Interfaces;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+
+namespace HeuristicLab.Problems.Scheduling.Encodings.PermutationWithRepetition.Crossovers {
+  [Item("PWR Generalization Order Crossover", "Represents a crossover operation swapping sequences of the parents to generate offspring.")]
+  [StorableClass]
+  public class PWRGOXCrossover : PWRCrossover{
+    [StorableConstructor]
+    protected PWRGOXCrossover(bool deserializing) : base(deserializing) { }
+    protected PWRGOXCrossover(PWRGOXCrossover original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PWRGOXCrossover(this, cloner);
+    }
+
+    public PWRGOXCrossover() : base() { }
+
+    public override PWREncoding Crossover(IRandom random, PWREncoding parent1, PWREncoding parent2) {
+      PWREncoding result = new PWREncoding();
+                                                                                           
+      List<int> p1 = ((IntegerVector)(parent1.PermutationWithRepetition.Clone())).ToList<int>();
+      List<int> p2 = ((IntegerVector)(parent2.PermutationWithRepetition.Clone())).ToList<int>();
+      List<int> child = new List<int> ();
+
+      int[] lookUpArrayP1 = GetLookUpForIndividual(p1);
+      int[] lookUpArrayP2 = GetLookUpForIndividual(p2);
+
+      int xStringLength = p1.Count / 2;
+      int xStringPosition = random.Next(p1.Count / 2);
+
+      //insert elements from parent1 that dont conflict with the "selected" elements form parent2
+      for (int i = 0; i < p1.Count; i++) {
+        bool isSelected = false;
+        for (int j = xStringPosition; j < xStringPosition + xStringLength; j++) {
+          if (p1[i] == p2[j] && lookUpArrayP1[i] == lookUpArrayP2[j])
+            isSelected = true;
+        }
+        if (!isSelected)
+          child.Add(p1[i]);
+      }
+
+      for (int i = xStringPosition; i < xStringPosition + xStringLength; i++) {
+        child.Insert(i, p2[i]);
+      }
+
+      result.PermutationWithRepetition = new IntegerVector(child.ToArray());
+      return result;
+    }
+
+    private int[] GetLookUpForIndividual(List<int> p) {
+      int[] result = new int[p.Count];
+      Dictionary<int, int> lookUpTable = new Dictionary<int, int>();
+
+      for (int i = 0; i < p.Count; i++) {
+        if (!lookUpTable.ContainsKey(p[i]))
+          lookUpTable.Add(p[i], 0);
+        result[i] = lookUpTable[p[i]];
+        lookUpTable[p[i]]++;
+      }
+
+      return result;
+    }
+
+
+  }
+}
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/Crossovers/PWRPPXCrossover.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/Crossovers/PWRPPXCrossover.cs	(revision 6260)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/Crossovers/PWRPPXCrossover.cs	(revision 6260)
@@ -0,0 +1,77 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Problems.Scheduling.Interfaces;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+
+namespace HeuristicLab.Problems.Scheduling.Encodings.PermutationWithRepetition.Crossovers {
+  [Item("PWR Order Crossover", "Represents a crossover operation swapping sequences of the parents to generate offspring.")]
+  [StorableClass]
+  public class PWRPPXCrossover : PWRCrossover{
+    [StorableConstructor]
+    protected PWRPPXCrossover(bool deserializing) : base(deserializing) { }
+    protected PWRPPXCrossover(PWRPPXCrossover original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PWRPPXCrossover(this, cloner);
+    }
+
+    public PWRPPXCrossover() : base() { }
+
+    public override PWREncoding Crossover(IRandom random, PWREncoding parent1, PWREncoding parent2) {
+      PWREncoding result = new PWREncoding();
+      List<int> p1 = ((IntegerVector)(parent1.PermutationWithRepetition.Clone())).ToList<int>();
+      List<int> p2 = ((IntegerVector)(parent2.PermutationWithRepetition.Clone())).ToList<int>();
+      List<int> child = new List<int>();
+
+      bool[] lookUpTable = new bool[parent1.PermutationWithRepetition.Length];
+      for (int i = 0; i < lookUpTable.Length; i++ ) {
+        lookUpTable[i] = random.Next(2) == 1;
+      }
+
+      foreach (bool b in lookUpTable) {
+        if (b) {
+          child.Add(p1[0]);
+          p2.Remove(p1[0]);
+          p1.RemoveAt(0);
+        } else {
+          child.Add(p2[0]);
+          p1.Remove(p2[0]);
+          p2.RemoveAt(0);
+        }
+      }
+
+      result.PermutationWithRepetition = new IntegerVector(child.ToArray());
+
+      return result;
+    }
+
+
+  }
+}
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/Manipulators/PWRManipulator.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/Manipulators/PWRManipulator.cs	(revision 6260)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/Manipulators/PWRManipulator.cs	(revision 6260)
@@ -0,0 +1,54 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.Scheduling.Encodings;
+using HeuristicLab.Problems.Scheduling.Encodings.JobSequenceMatrix;
+using HeuristicLab.Problems.Scheduling.Interfaces;
+
+namespace HeuristicLab.Problems.Scheduling.Encodings.PermutationWithRepetition.Manipulators {
+  [Item("PWRManipulator", "An operator which manipulates a PWR representation.")]
+  [StorableClass]
+  public abstract class PWRManipulator : JSSPManipulator<PWREncoding>, IPWROperator {
+    [StorableConstructor]
+    protected PWRManipulator(bool deserializing) : base(deserializing) { }
+    protected PWRManipulator(PWRManipulator original, Cloner cloner) : base(original, cloner) { }
+    public PWRManipulator()
+      : base() {
+    }
+
+    protected abstract PWREncoding Manipulate(IRandom random, PWREncoding individual);
+
+
+    public override IOperation Apply() {
+      PWREncoding solution = SchedulingSolutionParameter.ActualValue;
+
+      SchedulingSolutionParameter.ActualValue = Manipulate(RandomParameter.ActualValue, solution as PWREncoding);
+
+      return base.Apply();
+    }
+
+  }
+}
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/Manipulators/PWRUniformOnePositionManipulator.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/Manipulators/PWRUniformOnePositionManipulator.cs	(revision 6260)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/Manipulators/PWRUniformOnePositionManipulator.cs	(revision 6260)
@@ -0,0 +1,71 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Common;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+
+namespace HeuristicLab.Problems.Scheduling.Encodings.PermutationWithRepetition.Manipulators {
+
+  [Item("PWR Uniform One Position Manipulator", "Represents a manipulation operation inserting parts of the individual at another position.")]
+  [StorableClass]
+  public class PWRUniformOnePositionManipulator : PWRManipulator {
+    [StorableConstructor]
+    protected PWRUniformOnePositionManipulator(bool deserializing) : base(deserializing) { }
+    protected PWRUniformOnePositionManipulator(PWRUniformOnePositionManipulator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PWRUniformOnePositionManipulator(this, cloner);
+    }
+
+    public PWRUniformOnePositionManipulator() : base() { }
+
+    protected override PWREncoding Manipulate(IRandom random, PWREncoding individual) {
+      PWREncoding result = new PWREncoding();
+
+      int cutIndex = random.Next(individual.PermutationWithRepetition.Length);
+      int insertIndex = random.Next(individual.PermutationWithRepetition.Length);
+
+      List<int> perm = ((IntegerVector)(individual.PermutationWithRepetition.Clone ())).ToList<int>();
+
+      int aux = perm[cutIndex];
+      if (cutIndex > insertIndex) {
+        perm.RemoveAt(cutIndex);
+        perm.Insert(insertIndex, aux);
+      } else {
+        perm.Insert(insertIndex, aux); 
+        perm.RemoveAt(cutIndex);
+      }
+
+      result.PermutationWithRepetition = new IntegerVector(perm.ToArray());
+      
+      return result;
+    }
+
+  }
+}
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/PWRDecoder.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/PWRDecoder.cs	(revision 6260)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/PWRDecoder.cs	(revision 6260)
@@ -0,0 +1,71 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Problems.Scheduling.Encodings.PermutationWithRepetition {
+  [Item("PWRDecoder", "An item used to convert a PWR-individual into a generalized schedule.")]
+  [StorableClass]
+  public class PWRDecoder : JSSPDecoder<PWREncoding>, IStochasticOperator {
+    [StorableConstructor]
+    protected PWRDecoder(bool deserializing) : base(deserializing) { }
+    protected PWRDecoder(PWRDecoder original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PWRDecoder(this, cloner);
+    }
+
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
+    }
+
+    public PWRDecoder()
+      : base() {
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
+    }
+
+    public override Schedule CreateScheduleFromEncoding(PWREncoding solution) {
+      ItemList<JSSPJob> jobs = (ItemList<JSSPJob>)Jobs.Clone();
+      Schedule resultingSchedule = new Schedule(new IntValue(Jobs[0].Tasks.Count));
+      foreach (int jobNr in solution.PermutationWithRepetition) {
+        int i = 0;
+        while (jobs[jobNr].Tasks[i].IsScheduled.Value) i++;
+        jobs[jobNr].Tasks[i].IsScheduled.Value = true;
+        resultingSchedule.AddTask(jobs[jobNr].Tasks[i], jobs[jobNr]);
+      }
+      return resultingSchedule;
+    }
+
+    public override IOperation Apply() {
+      return base.Apply();
+    } 
+  }
+}
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/PWREncoding.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/PWREncoding.cs	(revision 6260)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/PWREncoding.cs	(revision 6260)
@@ -0,0 +1,81 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.Scheduling.Interfaces;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+
+namespace HeuristicLab.Problems.Scheduling.Encodings.PermutationWithRepetition {
+  [Item("Permutation With Repetition Encoding", "Represents a solution for a standard JobShop Scheduling Problem.")]
+  [StorableClass]
+  public class PWREncoding : ParameterizedNamedItem, ISchedulingEncoding{
+    [StorableConstructor]
+    protected PWREncoding(bool deserializing) : base(deserializing) { }
+    protected PWREncoding(PWREncoding original, Cloner cloner)
+      : base(original, cloner) {
+        this.PermutationWithRepetition = cloner.Clone(original.PermutationWithRepetition);
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PWREncoding(this, cloner);
+    }
+
+    [Storable]
+    public IntegerVector PermutationWithRepetition { get; set; }
+
+    public PWREncoding() 
+      : base () {
+      PermutationWithRepetition = new IntegerVector();
+    }
+
+    public PWREncoding(int problemDimension, IRandom random)
+      : base() {
+      PermutationWithRepetition = new IntegerVector(problemDimension * problemDimension);
+      int[] lookUpTable = new int[problemDimension];
+
+      for (int i = 0; i < PermutationWithRepetition.Length; i++) {
+        int newValue = random.Next(problemDimension);
+        while (lookUpTable[newValue] >= problemDimension)
+          newValue = random.Next(problemDimension);
+
+        PermutationWithRepetition[i] = newValue;
+
+        lookUpTable[newValue]++;
+      }
+    }
+
+    public override string ToString() {
+      StringBuilder sb = new StringBuilder();
+      sb.Append("[ ");
+      foreach (int i in PermutationWithRepetition) {
+        sb.Append(i + " ");
+      }
+      sb.Append("]");
+
+      return sb.ToString();
+    }
+  }
+}
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/PWRRandomCreator.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/PWRRandomCreator.cs	(revision 6260)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PermutationWithRepetition/PWRRandomCreator.cs	(revision 6260)
@@ -0,0 +1,64 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Common;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+
+namespace HeuristicLab.Problems.Scheduling.Encodings.PermutationWithRepetition {
+  [Item("Permutation With Repetition Random Creator", "Creates PWR-individuals at random.")]
+  [StorableClass]
+  public class PWRRandomCreator : JSSPCreator<PWREncoding>, IStochasticOperator {
+    [StorableConstructor]
+    protected PWRRandomCreator(bool deserializing) : base(deserializing) { }
+    protected PWRRandomCreator(PWRRandomCreator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PWRRandomCreator(this, cloner);
+    }
+
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
+    }
+
+    public IRandom Random {
+      get { return RandomParameter.ActualValue; }
+    }
+
+    public PWRRandomCreator()
+      : base() {
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator."));
+    }
+
+
+    protected override PWREncoding CreateSolution() {
+      PWREncoding result = new PWREncoding(Jobs.Count, Random);
+      return result;
+    }
+  }
+}
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/Crossovers/PRVCrossover.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/Crossovers/PRVCrossover.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/Crossovers/PRVCrossover.cs	(revision 6260)
@@ -28,7 +28,7 @@
 
 namespace HeuristicLab.Problems.Scheduling.Encodings.PriorityRulesVector.Crossovers {
-  [Item("JSMCrossover", "An operator which crosses two JSM representations.")]
+  [Item("PRVCrossover", "An operator which crosses two PRV representations.")]
   [StorableClass]
-  public abstract class PRVCrossover : JSSPCrossover, IPRVOperator {
+  public abstract class PRVCrossover : JSSPCrossover<PRVEncoding>, IPRVOperator {
 
     [StorableConstructor]
@@ -39,8 +39,8 @@
     }
 
-    public abstract IJSSPEncoding Crossover(IRandom random, PRVEncoding parent1, PRVEncoding parent2);
+    public abstract PRVEncoding Crossover(IRandom random, PRVEncoding parent1, PRVEncoding parent2);
 
     public override IOperation Apply() {
-      ItemArray<IJSSPEncoding> parents = ParentsParameter.ActualValue;
+      ItemArray<PRVEncoding> parents = ParentsParameter.ActualValue;
 
       ChildParameter.ActualValue =
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/Crossovers/PRVDiscreteCrossover.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/Crossovers/PRVDiscreteCrossover.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/Crossovers/PRVDiscreteCrossover.cs	(revision 6260)
@@ -45,9 +45,9 @@
     public PRVDiscreteCrossover() : base() { }
 
-    public static IJSSPEncoding Cross(IRandom random, PRVEncoding parent1, PRVEncoding parent2) {
+    public static PRVEncoding Cross(IRandom random, PRVEncoding parent1, PRVEncoding parent2) {
       return new PRVEncoding(DiscreteCrossover.Apply(random, parent1, parent2), parent1.NrOfRules);
     }
 
-    public override IJSSPEncoding Crossover(IRandom random, PRVEncoding parent1, PRVEncoding parent2) {
+    public override PRVEncoding Crossover(IRandom random, PRVEncoding parent1, PRVEncoding parent2) {
       return Cross(random, parent1, parent2);
     } 
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/Crossovers/PRVSinglePointCrossover.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/Crossovers/PRVSinglePointCrossover.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/Crossovers/PRVSinglePointCrossover.cs	(revision 6260)
@@ -45,10 +45,10 @@
     public PRVSinglePointCrossover() : base() { }
 
-    public static IJSSPEncoding Cross(IRandom random, PRVEncoding parent1, PRVEncoding parent2) {
+    public static PRVEncoding Cross(IRandom random, PRVEncoding parent1, PRVEncoding parent2) {
       return new PRVEncoding(SinglePointCrossover.Apply(random, parent1, parent2), parent1.NrOfRules);
     }
 
-    public override IJSSPEncoding Crossover(IRandom random, PRVEncoding parent1, PRVEncoding parent2) {
-      return Cross(random, parent1, parent2);
+    public override PRVEncoding Crossover(IRandom random, PRVEncoding parent1, PRVEncoding parent2) {
+      return Cross(random, parent1, parent2);;
     } 
   }
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/Manipulators/PRVManipulator.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/Manipulators/PRVManipulator.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Encodings/PriorityRulesVector/Manipulators/PRVManipulator.cs	(revision 6260)
@@ -30,7 +30,7 @@
 
 namespace HeuristicLab.Problems.Scheduling.Encodings.PriorityRulesVector.Manipulators {
-  [Item("AlbaManipulator", "An operator which manipulates a VRP representation.")]
+  [Item("PRVManipulator", "An operator which manipulates a PRV representation.")]
   [StorableClass]
-  public abstract class PRVManipulator : JSSPManipulator, IPRVOperator {
+  public abstract class PRVManipulator : JSSPManipulator<PRVEncoding>, IPRVOperator {
     [StorableConstructor]
     protected PRVManipulator(bool deserializing) : base(deserializing) { }
@@ -44,5 +44,5 @@
 
     public override IOperation Apply() {
-      IJSSPEncoding solution = SchedulingSolutionParameter.ActualValue;
+      PRVEncoding solution = SchedulingSolutionParameter.ActualValue;
 
       SchedulingSolutionParameter.ActualValue = Manipulate(RandomParameter.ActualValue, solution as PRVEncoding);
